using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Sys_OperateLogs
	/// </summary>
	public partial class T_Sys_OperateLogs
    {
        public T_Sys_OperateLogs()
        { }
        #region  BasicMethod

        /// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(CallCenterApi.Model.T_Sys_OperateLogs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_OperateLogs(");
            strSql.Append("F_OptBy,F_OptIP,F_OptOn,F_OptCode,F_Module,F_OptTables,F_OptID,F_Descript)");
            strSql.Append(" values (");
            strSql.Append("@F_OptBy,@F_OptIP,@F_OptOn,@F_OptCode,@F_Module,@F_OptTables,@F_OptID,@F_Descript)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OptBy", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_OptIP", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_OptOn", SqlDbType.DateTime),
                    new SqlParameter("@F_OptCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Module", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_OptTables", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_OptID", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Descript", SqlDbType.NText)};
            parameters[0].Value = model.F_OptBy;
            parameters[1].Value = model.F_OptIP;
            parameters[2].Value = model.F_OptOn;
            parameters[3].Value = model.F_OptCode;
            parameters[4].Value = model.F_Module;
            parameters[5].Value = model.F_OptTables;
            parameters[6].Value = model.F_OptID;
            parameters[7].Value = model.F_Descript;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }

        /// <summary>
		/// 得到一个对象实体
		/// </summary>
		public CallCenterApi.Model.T_Sys_OperateLogs DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_OperateLogs model = new CallCenterApi.Model.T_Sys_OperateLogs();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_OptBy"] != null)
                {
                    model.F_OptBy = row["F_OptBy"].ToString();
                }
                if (row["F_OptIP"] != null)
                {
                    model.F_OptIP = row["F_OptIP"].ToString();
                }
                if (row["F_OptOn"] != null && row["F_OptOn"].ToString() != "")
                {
                    model.F_OptOn = DateTime.Parse(row["F_OptOn"].ToString());
                }
                if (row["F_OptCode"] != null)
                {
                    model.F_OptCode = row["F_OptCode"].ToString();
                }
                if (row["F_Module"] != null)
                {
                    model.F_Module = row["F_Module"].ToString();
                }
                if (row["F_OptTables"] != null)
                {
                    model.F_OptTables = row["F_OptTables"].ToString();
                }
                if (row["F_OptID"] != null)
                {
                    model.F_OptID = row["F_OptID"].ToString();
                }
                if (row["F_Descript"] != null)
                {
                    model.F_Descript = row["F_Descript"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Sys_OperateLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Sys_OperateLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_OperateLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_OperateLogs T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }
        
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
